#!/bin/bash
pushd DCPEQX/manual ; make clean; popd;
pushd SCPEQX/manual ; make clean ; popd;
pushd DCPEQX/manual ; make ; popd;
pushd SCPEQX/manual ; make ; popd;
pushd FSMDEQX/FSMDEQX-PE ; make ; popd;
pushd FSMDEQX/FSMDEQX-PE ; make ; popd;



 DCPEQX/manual/./pres DCPEQX/manual/example/sequential/MODN/MODN_ORG.PRES DCPEQX/manual/example/sequential/MODN/MODN_TRANS.PRES > results/DCPEQX_MANUAL/sequential/MODN/VerificationReport.txt;

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/DCT/DCT_ORG.PRES  DCPEQX/manual/example/sequential/DCT/DCT_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/DCT/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/GCD/GCD_ORG.PRES  DCPEQX/manual/example/sequential/GCD/GCD_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/GCD/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/LCM/LCM_ORG.PRES  DCPEQX/manual/example/sequential/LCM/LCM_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/LCM/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/PERFECT/PERFECT_ORG.PRES  DCPEQX/manual/example/sequential/PERFECT/PERFECT_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/PERFECT/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/PRIMEFAC/PRIMEFAC_ORG.PRES  DCPEQX/manual/example/sequential/PRIMEFAC/PRIMEFAC_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/PRIMEFAC/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/SOD/SOD_ORG.PRES  DCPEQX/manual/example/sequential/SOD/SOD_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/SOD/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/TLC/TLC_ORG.PRES  DCPEQX/manual/example/sequential/TLC/TLC_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/TLC/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/LRU/LRU_ORG.PRES  DCPEQX/manual/example/sequential/LRU/LRU_TRANS.PRES >  results/DCPEQX_MANUAL/sequential/LRU/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/sequential/MINANDMAX-S/MINMAX_ORG.PRES  DCPEQX/manual/example/sequential/MINANDMAX-S/MINMAX_TRANS.PRES >   results/DCPEQX_MANUAL/sequential/MINANDMAX-S/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/BCM/BCM_ORG.PRES  DCPEQX/manual/example/parallel/BCM/BCM_TRANS_PLUTO.PRES >   results/DCPEQX_MANUAL/parallel/BCM/VerificationReport_PLUTO.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/BCM/BCM_ORG.PRES  DCPEQX/manual/example/parallel/BCM/BMC_TRANS_PAR4ALL.PRES >   results/DCPEQX_MANUAL/parallel/BCM/VerificationReport_PAR4ALL.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/MINANDMAX-P/MINMAX_ORG.PRES  DCPEQX/manual/example/parallel/MINANDMAX-P/MINMAX_TRANS.PRES >   results/DCPEQX_MANUAL/parallel/MINANDMAX-P/VerificationReport_PLUTO.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/MINANDMAX-P/MINMAX_ORG.PRES  DCPEQX/manual/example/parallel/MINANDMAX-P/MINMAX_TRANS.PRES >   results/DCPEQX_MANUAL/parallel/MINANDMAX-P/VerificationReport_PAR4ALL.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/LUP/LUP_ORG.PRES  DCPEQX/manual/example/parallel/LUP/LUP_TRANS_PAR4ALL.PRES >   results/DCPEQX_MANUAL/parallel/LUP/VerificationReport_PLUTOANDPAR4ALL.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/DEKKERS/DEKKER_ORG.PRES  DCPEQX/manual/example/parallel/DEKKERS/DEKKER_TRANS_PAR4ALL.PRES >   results/DCPEQX_MANUAL/parallel/DEKKERS/VerificationReport_PLUTOANDPAR4ALL.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/PATTERSON/PATTERSON_ORG.PRES  DCPEQX/manual/example/parallel/PATTERSON/PATTERSON_TRANS_PAR4ALL.PRES >   results/DCPEQX_MANUAL/parallel/PATTERSON/VerificationReport_PLUTOANDPAR4All.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/MODN/MODN_ORG.PRES  DCPEQX/manual/example/faultyExample/MODN/MODN_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/MODN/VerificationReport.txt

DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/LRU/LRU_ORG.PRES  DCPEQX/manual/example/faultyExample/LRU/LRU_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/LRU/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/LRU/LRU_ORG.PRES  DCPEQX/manual/example/faultyExample/LRU/LRU_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/LRU/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/parallel/DEKKERS/DEKKER_ORG.PRES  DCPEQX/manual/example/parallel/DEKKERS/DEKKER_TRANS_PAR4ALL.PRES >  DCPEQX/manual/example/parallel/DEKKERS/VerificationReport_PAR4ALL.tx

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/GCD/GCD_ORG.PRES  DCPEQX/manual/example/faultyExample/GCD/GCD_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/GCD/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/GCD/GCD_ORG.PRES  DCPEQX/manual/example/faultyExample/GCD/GCD_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/LCM/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/MINANDMAX-P/MINMAX_ORG.PRES  DCPEQX/manual/example/faultyExample/MINANDMAX-P/MINMAX_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/MINANDMAX-P/VerificationReport.txt

 DCPEQX/manual/./pres  DCPEQX/manual/example/faultyExample/PATTERSON/PATTERSON_ORG.PRES  DCPEQX/manual/example/faultyExample/PATTERSON/PATTERSON_FAULT.PRES >  results/DCPEQX_MANUAL/faultyExample/PATTERSON/VerificationReport.txt





 SCPEQX/manual/./pres SCPEQX/manual/example/sequential/MODN/MODN_ORG.PRES SCPEQX/manual/example/sequential/MODN/MODN_TRANS.PRES > results/SCPEQX_MANUAL/sequential/MODN/VerificationReport.txt

SCPEQX/manual/./pres SCPEQX/manual/example/sequential/SOD/SOD_ORG.PRES SCPEQX/manual/example/sequential/SOD/SOD_TRANS.PRES > results/SCPEQX_MANUAL/sequential/SOD/VerificationReport.txt

SCPEQX/manual/./pres SCPEQX/manual/example/sequential/GCD/GCD_TRANS.PRES SCPEQX/manual/example/sequential/GCD/GCD_ORG.PRES > results/SCPEQX_MANUAL/sequential/GCD/VerificationReport.txt

SCPEQX/manual/./pres SCPEQX/manual/example/sequential/LCM/LCM_ORG.PRES SCPEQX/manual/example/sequential/LCM/LCM_TRANS.PRES > results/SCPEQX_MANUAL/sequential/LCM/VerificationReport.txt

SCPEQX/manual/./pres SCPEQX/manual/example/sequential/LRU/LRU_ORG.PRES SCPEQX/manual/example/sequential/LRU/LRU_TRANS.PRES > results/SCPEQX_MANUAL/sequential/LRU/VerificationReport.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/sequential/PRIMEFAC/primefac_org.pres SCPEQX/manual/example/sequential/PRIMEFAC/primefac_schd.pres > results/SCPEQX_MANUAL/sequential/PRIMEFAC/VerificationReport.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/sequential/TLC/TLC.pres SCPEQX/manual/example/sequential/TLC/TLC_Trans.pres > results/SCPEQX_MANUAL/sequential/TLC/VerificationReport.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/sequential/PERFECT/perfect_org.pres SCPEQX/manual/example/sequential/PERFECT/perfect_shd.pres > results/SCPEQX_MANUAL/sequential/PERFECT/VerificationReport.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/sequential/MINANDMAX-S/MAX_ORG.PRES SCPEQX/manual/example/sequential/MINANDMAX-S/MAX_TRANS.PRES > results/SCPEQX_MANUAL/sequential/MINANDMAX-S/VerificationReport.txt

SCPEQX/manual/./pres SCPEQX/manual/example/parallel/BCM/BCM_ORG.PRES SCPEQX/manual/example/parallel/BCM/BCM_TRANS.PRES > results/SCPEQX_MANUAL/parallel/BCM/VerificationReportPLUTO.txt

SCPEQX/manual/./pres SCPEQX/manual/example/parallel/BCM/BCM_ORG.PRES SCPEQX/manual/example/parallel/BCM/BCM_TRANS.PRES > results/SCPEQX_MANUAL/parallel/BCM/VerificationReportPAR4ALL.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_ORG.PRES SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_TRANS.PRES > results/SCPEQX_MANUAL/parallel/MINANDMAX-P/VerificationReport_PLUTO.txt

SCPEQX/manual/./pres SCPEQX/manual/example/sequential/GCD/GCD_TRANS.PRES SCPEQX/manual/example/sequential/GCD/GCD_ORG.PRES > results/SCPEQX_MANUAL/sequential/GCD/VerificationReport.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_ORG.PRES SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_TRANS.PRES > results/SCPEQX_MANUAL/parallel/MINANDMAX-P/VerificationReport_PAR4ALL.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_ORG.PRES SCPEQX/manual/example/parallel/MINANDMAX-P/MAX_TRANS.PRES > results/SCPEQX_MANUAL/parallel/MINANDMAX-P/VerificationReport_PAR4ALL.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/LUP/LUP_ORG.PRES SCPEQX/manual/example/parallel/LUP/LUP_TRANS.PRES > results/SCPEQX_MANUAL/parallel/LUP/VerificationReport_PAR4ALL.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/LUP/LUP_ORG.PRES SCPEQX/manual/example/parallel/LUP/LUP_TRANS.PRES > results/SCPEQX_MANUAL/parallel/LUP/VerificationReport_PLUTO.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/DEKKER/DEKKER_ORG.PRES SCPEQX/manual/example/parallel/DEKKER/DEKKER_TRANS_PLUTO.PRES > results/SCPEQX_MANUAL/parallel/DEKKERS/VerificationReport_PLUTO.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/DEKKER/DEKKER_ORG.PRES SCPEQX/manual/example/parallel/DEKKER/DEKKER_TRANS_PLUTO.PRES > results/SCPEQX_MANUAL/parallel/DEKKERS/VerificationReport_PAR4ALL.txt

 SCPEQX/manual/./pres SCPEQX/manual/example/parallel/DEKKER/DEKKER_ORG.PRES SCPEQX/manual/example/parallel/DEKKER/DEKKER_TRANS_PLUTO.PRES > results/SCPEQX_MANUAL/parallel/PATTERSON/VerificationReport_PAR4ALLANDPLUTO.txt

SCPEQX/manual/./pres  SCPEQX/manual/example/faultyExample/MODN/MODN_ORG.PRES  SCPEQX/manual/example/faultyExample/MODN/MODN_FAULT.PRES >  results/SCPEQX_MANUAL/faultyExample/MODN/VerificationReport.txt

SCPEQX/manual/./pres  SCPEQX/manual/example/faultyExample/LCM/LCM_ORG.PRES  SCPEQX/manual/example/faultyExample/LCM/LCM_FAULT.PRES >  results/SCPEQX_MANUAL/faultyExample/LCM/VerificationReport.txt

SCPEQX/manual/./pres  SCPEQX/manual/example/faultyExample/LRU/LRU_ORG.PRES  SCPEQX/manual/example/faultyExample/LRU/LRU_FAULT.PRES >  results/SCPEQX_MANUAL/faultyExample/LRU/VerificationReport.txt

SCPEQX/manual/./pres  SCPEQX/manual/example/faultyExample/GCD/LCM_ORG.PRES  SCPEQX/manual/example/faultyExample/GCD/LCM_FAULT.PRES >  results/SCPEQX_MANUAL/faultyExample/GCD/VerificationReport.txt

SCPEQX/manual/./pres  SCPEQX/manual/example/faultyExample/MINANDMAX-P/MINMAX_ORG.PRES  SCPEQX/manual/example/faultyExample/MINANDMAX-P/MINMAX_FAULT.PRES >  results/SCPEQX_MANUAL/faultyExample/MINANDMAX-P/VerificationReport.txt









FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/BARCODE/barcode.org FSMDEQX/FSMDEQX-PE/examples/BARCODE/barcode.schd > results/FSMDEQX-PE/correctExamples/BARCODE/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/DCT/dct.org FSMDEQX/FSMDEQX-PE/examples/DCT/dct.schd > results/FSMDEQX-PE/correctExamples/DCT/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/DHRC/dhrc.org FSMDEQX/FSMDEQX-PE/examples/DHRC/dhrc.schd > results/FSMDEQX-PE/correctExamples/DHRC/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/DIFFEQ/diffeq.org FSMDEQX/FSMDEQX-PE/examples/DIFFEQ/diffeq.schd > results/FSMDEQX-PE/correctExamples/DIFFEQ/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/EWF/ewf.org FSMDEQX/FSMDEQX-PE/examples/EWF/dct.schd > results/FSMDEQX-PE/correctExamples/EWF/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/GCD/gcd.org FSMDEQX/FSMDEQX-PE/examples/GCD/gcd.schd > results/FSMDEQX-PE/correctExamples/GCD/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/LCM/LCM.org FSMDEQX/FSMDEQX-PE/examples/LCM/LCM.schd > results/FSMDEQX-PE/correctExamples/LCM/VefificationLCM.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/IEEE754/ieee754.org FSMDEQX/FSMDEQX-PE/examples/IEEE754/ieee754.schd > results/FSMDEQX-PE/correctExamples/IEEE754/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/LRU/lru.org FSMDEQX/FSMDEQX-PE/examples/LRU/lru.schd > results/FSMDEQX-PE/correctExamples/LRU/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/MODN/modn.org FSMDEQX/FSMDEQX-PE/examples/MODN/modn.schd > results/FSMDEQX-PE/correctExamples/MODN/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/PERFECT/perfect.org FSMDEQX/FSMDEQX-PE/examples/PERFECT/perfect.schd > results/FSMDEQX-PE/correctExamples/PERFECT/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/SOD/sod.org FSMDEQX/FSMDEQX-PE/examples/SOD/sod.schd > results/FSMDEQX-PE/correctExamples/SOD/Verification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/PRAWN/prawn.org FSMDEQX/FSMDEQX-PE/examples/PRAWN/prawn.schd > results/FSMDEQX-PE/correctExamples/PRAWN/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/TLC/TLC.org FSMDEQX/FSMDEQX-PE/examples/TLC/TLC.schd > results/FSMDEQX-PE/correctExamples/TLC/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/examples/QRS/QRS.org FSMDEQX/FSMDEQX-PE/examples/QRS/QRS.schd > results/FSMDEQX-PE/correctExamples/QRS/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/faultExample/LRU/lru.org FSMDEQX/FSMDEQX-PE/examples/LRU-CM/lru.schd > results/FSMDEQX-PE/faultExamples/LRU/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/faultExample/GCD/gcd.org FSMDEQX/FSMDEQX-PE/examples/GCD/gcd.schd > results/FSMDEQX-PE/faultExamples/GCD/Vefification.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/faultExample/LCM/LCM.org FSMDEQX/FSMDEQX-PE/examples/LCM/LCM.schd > results/FSMDEQX-PE/faultExamples/LCM/VefificationLCM.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/faultExample/TLC/tlc.org FSMDEQX/FSMDEQX-PE/examples/TLC/tlc.schd > results/FSMDEQX-PE/faultExamples/TLC/VefificationLCM.txt

FSMDEQX/FSMDEQX-PE/bin/./PEFsmd FSMDEQX/FSMDEQX-PE/faultExample/MODN/modn.org FSMDEQX/FSMDEQX-PE/examples/MODN/modn.schd > results/FSMDEQX-PE/faultExamples/MODN/Vefification.txt








FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/BARCODE/barcode.org FSMDEQX/FSMDEQX-VP/examples/BARCODE/barcode.schd > results/FSMDEQX-VP/correctExamples/BARCODE/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/DCT/dct.org FSMDEQX/FSMDEQX-VP/examples/DCT/dct.schd > results/FSMDEQX-VP/correctExamples/DCT/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/DHRC/dhrc.org FSMDEQX/FSMDEQX-VP/examples/DHRC/dhrc.schd > results/FSMDEQX-VP/correctExamples/DHRC/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/DIFFEQ/diffeq.org FSMDEQX/FSMDEQX-VP/examples/DIFFEQ/diffeq.schd > results/FSMDEQX-VP/correctExamples/DIFFEQ/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/EWF/ewf.org FSMDEQX/FSMDEQX-VP/examples/EWF/dct.schd > results/FSMDEQX-VP/correctExamples/EWF/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/GCD/gcd.org FSMDEQX/FSMDEQX-VP/examples/GCD/gcd.schd > results/FSMDEQX-VP/correctExamples/GCD/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/LCM/LCM.org FSMDEQX/FSMDEQX-VP/examples/LCM/LCM.schd > results/FSMDEQX-VP/correctExamples/LCM/VefificationLCM.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/IEEE754/ieee754.org FSMDEQX/FSMDEQX-VP/examples/IEEE754/ieee754.schd > results/FSMDEQX-VP/correctExamples/IEEE754/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/LRU/lru.org FSMDEQX/FSMDEQX-VP/examples/LRU/lru.schd > results/FSMDEQX-VP/correctExamples/LRU/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/MODN/modn.org FSMDEQX/FSMDEQX-VP/examples/MODN/modn.schd > results/FSMDEQX-VP/correctExamples/MODN/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/PERFECT/perfect.org FSMDEQX/FSMDEQX-VP/examples/PERFECT/perfect.schd > results/FSMDEQX-VP/correctExamples/PERFECT/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/SOD/sod.org FSMDEQX/FSMDEQX-VP/examples/SOD/sod.schd > results/FSMDEQX-VP/correctExamples/SOD/Verification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/PRAWN/prawn.org FSMDEQX/FSMDEQX-VP/examples/PRAWN/prawn.schd > results/FSMDEQX-VP/correctExamples/PRAWN/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/TLC/TLC.org FSMDEQX/FSMDEQX-VP/examples/TLC/TLC.schd > results/FSMDEQX-VP/correctExamples/TLC/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/QRS/QRS.org FSMDEQX/FSMDEQX-VP/examples/QRS/QRS.schd > results/FSMDEQX-VP/correctExamples/QRS/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/IEEE754-CM/ieee754.org FSMDEQX/FSMDEQX-VP/examples/IEEE754-CM/ieee754.schd > results/FSMDEQX-VP/correctExamples/IEEE754-CM/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/LCM-CM/LCM.org FSMDEQX/FSMDEQX-VP/examples/LCM-CM/LCM.schd > results/FSMDEQX-VP/correctExamples/LCM-CM/VefificationLCM.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/PERFECT-CM/perfect.org FSMDEQX/FSMDEQX-VP/examples/PERFECT-CM/perfect.schd > results/FSMDEQX-VP/correctExamples/PERFECT-CM/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/QRS-CM/QRS.org FSMDEQX/FSMDEQX-VP/examples/QRS-CM/QRS.schd > results/FSMDEQX-VP/correctExamples/QRS-CM/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/examples/LRU-CM/lru.org FSMDEQX/FSMDEQX-VP/examples/LRU-CM/lru.schd > results/FSMDEQX-VP/correctExamples/LRU-CM/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/faultExample/LRU/lru.org FSMDEQX/FSMDEQX-VP/examples/LRU-CM/lru.schd > results/FSMDEQX-VP/faultExamples/LRU/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/faultExample/GCD/gcd.org FSMDEQX/FSMDEQX-VP/examples/GCD/gcd.schd > results/FSMDEQX-VP/faultExamples/GCD/Vefification.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/faultExample/GCD/LCM.org FSMDEQX/FSMDEQX-VP/examples/LCM/LCM.schd > results/FSMDEQX-VP/faultExamples/LCM/VefificationLCM.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/faultExample/TLC/tlc.org FSMDEQX/FSMDEQX-VP/examples/TLC/tlc.schd > results/FSMDEQX-VP/faultExamples/TLC/VefificationLCM.txt

FSMDEQX/FSMDEQX-VP/bin/./valPropFsmd FSMDEQX/FSMDEQX-VP/MODN/modn.org FSMDEQX/FSMDEQX-VP/examples/MODN/modn.schd > results/FSMDEQX-VP/faultExamples/MODN/Vefification.txt











